# $Revision: 1.44 $, $Date: 2010/04/21 11:36:44 $
%define 	jpackage_distver 1.7
Summary:	JPackage utilities
Summary(pl.UTF-8):	Narzędzia JPackage
Name:		jpackage-utils
Version:	1.7.5
Release:	3
Epoch:		0
License:	BSD-like
Group:		Development/Languages/Java
Source0:	%{name}-%{version}.tar.bz2
# Source0-md5:	5039b51d1e80e45da27faf131448eaa8
Patch0:		%{name}-pdksh.patch
Patch1:		%{name}-checkdir.patch
Patch2:		%{name}-errors.patch
Patch3:		%{name}-noyelling.patch
Patch4:		%{name}-readlink.patch
Patch5:		%{name}-jvm_exports_via_link.patch
URL:		http://www.jpackage.org/
BuildRequires:	rpmbuild(macros) >= 1.555
Requires:	/bin/egrep
Requires:	/bin/sed
Requires:	which
Conflicts:	rpmbuild(macros) < 1.409
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Utilities from the JPackage Project <http://www.jpackage.org/>:

- build-classpath - build the Java classpath in a portable manner
- build-jar-repository - build a jar repository in a portable manner
- rebuild-jar-repository - rebuild a jar repository in a portable
  manner (after a jvm change...)
- build-classpath-directory - build the Java classpath from a
  directory
- diff-jars - show jar content differences
- jvmjar - install jvm extensions
- create-jar-links - create custom jar links
- clean-binary-files - remove binary files from sources
- check-binary-files - check for presence of unexpected binary files
- %{_datadir}/java-utils/java-functions - shell script functions
  library for Java applications
- %{_sysconfdir}/java/jpackage-release - string identifying the
  currently installed JPackage release
- %{_sysconfdir}/java/java.conf - system-wide Java configuration file
- %{_docdir}/%{name}-%{version}/jpackage-policy - Java packaging
  policy for packagers and developers of JPackage Project

It contains also the License, man pages, documentation, XSL files of
general use with maven2, a header file for spec files etc.

%description -l pl.UTF-8
Narzędzia z projektu JPackage <http://www.jpackage.org/>:

- build-classpath tworzy ścieżkę do klas (classpath) Javy w sposób
  przenośny
- build-jar-repository tworzy repozytorium jar w sposób przenośny
- rebuild-jar-repository przebudowuje repozytorium jar w przenośny
  sposób (po zmianie jvm)
- build-classpath-directory tworzy ścieżkę do klas (classpath) Javy
  z katalogu
- diff-jars pokazuje różnice między zawartością jarów
- jvmjar instaluje rozszerzenia jvm
- create-jar-links tworzy własne dowiązania do jarów
- clean-binary-files usuwa binarne pliki ze źródeł
- check-binary-files sprawdza istnienie nieoczekiwanych plików
  binarnych
- %{_datadir}/java-utils/java-functions to biblioteka funkcji
  skryptów powłoki dla aplikacji w Javie
- %{_sysconfdir}/java/jpackage-release to łańcuch określający
  aktualnie zainstalowane wydanie JPackage
- %{_sysconfdir}/java/java.conf to ogólnosystemowy plik
  konfiguracyjny Javy
- %{_docdir}/%{name}-%{version}/jpackage-policy to polityka
  pakietowania Javy dla osób pakietujących i programistów z projektu
  JPackage

Pakiet zawiera także treść licencji, strony manuala, dokumentację,
pliki XSL dla programu maven2, plik nagłówkowy dla plików spec itp.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

# we cp -a complete dir from source
find '(' -name '*~' -o -name '*.orig' ')' -print0 | xargs -0 -r -l512 rm -f

%build
echo "JPackage release %{jpackage_distver} (PLD Linux port) for %{_build_arch}" > etc/jpackage-release

%install
rm -rf $RPM_BUILD_ROOT

# arch independant
install -d $RPM_BUILD_ROOT{%{_bindir},%{_sysconfdir}/java,/etc/env.d,%{_javadocdir},%{_javasrcdir},%{_javadir}} \
	$RPM_BUILD_ROOT{%{_jvmsysconfdir},%{_jvmcommondatadir},%{_jvmdatadir},%{_jvmcommonsysconfdir}} \
	$RPM_BUILD_ROOT%{_javadir}-{utils,ext,1.4.0,1.4.1,1.4.2,1.5.0,1.6.0} \
	$RPM_BUILD_ROOT%{_mavendepmapdir}

# arch dependant
install -d \
	$RPM_BUILD_ROOT{%{_jvmdir},%{_jvmjardir},%{_jvmprivdir},%{_jvmcommonlibdir},%{_jnidir}} \
	$RPM_BUILD_ROOT%{_jnidir}-{ext,1.4.0,1.4.1,1.4.2,1.5.0,1.6.0}

%if "%{_lib}" != "lib"
%define _ujvmdir			%{_prefix}/lib/jvm
%define _ujvmjardir			%{_prefix}/lib/jvm-exports
%define _ujvmprivdir		%{_prefix}/lib/jvm-private
%define _ujvmcommonlibdir	%{_prefix}/lib/jvm-common
%define _ujnidir			%{_prefix}/lib/java
%define _ujvmlibdir			%{_prefix}/lib/jvm

install -d \
	$RPM_BUILD_ROOT{%{_ujvmdir},%{_ujvmjardir},%{_ujvmprivdir},%{_ujvmcommonlibdir},%{_ujnidir}} \
	$RPM_BUILD_ROOT%{_ujnidir}-{ext,1.4.0,1.4.1,1.4.2,1.5.0,1.6.0}
%endif

install -pm 755 bin/* $RPM_BUILD_ROOT%{_bindir}
install -pm 644 etc/font.properties $RPM_BUILD_ROOT%{_sysconfdir}/java

# Create an initial (empty) depmap
echo -e "<dependencies>\\n" > ${RPM_BUILD_ROOT}%{_mavendepmapdir}/maven2-depmap.xml
echo -e "</dependencies>\\n" >> ${RPM_BUILD_ROOT}%{_mavendepmapdir}/maven2-depmap.xml

cat > etc/java.conf << 'EOF'
# System-wide Java configuration file                                -*- sh -*-
#
# JPackage Project <http://www.jpackage.org/>

# Location of jar files on the system
JAVA_LIBDIR=%{_javadir}

# Location of arch-specific jar files on the system
JNI_LIBDIR=%{_jnidir}

# Root of all JVM installations
JVM_ROOT=%{_jvmdir}

# You can define a system-wide JVM root here if you're not using the default one
#JAVA_HOME=$JVM_ROOT/java

# Options to pass to the java interpreter
JAVACMD_OPTS=
EOF

install -pm 644 etc/java.conf $RPM_BUILD_ROOT%{_sysconfdir}/java
install -pm 644 etc/jpackage-release $RPM_BUILD_ROOT%{_sysconfdir}/java
install -pm 644 java-utils/* $RPM_BUILD_ROOT%{_javadir}-utils
install -d $RPM_BUILD_ROOT%{_mandir}/man1
cp -a man/* $RPM_BUILD_ROOT%{_mandir}/man1
install -d $RPM_BUILD_ROOT%{_javadir}-utils/xml
cp -a xml/* $RPM_BUILD_ROOT%{_javadir}-utils/xml

cat << 'EOF' >$RPM_BUILD_ROOT/etc/env.d/JAVA_HOME
JAVA_HOME=$(. %{_javadir}-utils/java-functions; set_jvm >&2; echo "$JAVA_HOME")
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post
%env_update

%postun
%env_update

%files
%defattr(644,root,root,755)
%doc LICENSE.txt doc/* etc/httpd-javadoc.conf
%attr(755,root,root) %{_bindir}/*
%dir %{_sysconfdir}/java
%config %{_sysconfdir}/java/jpackage-release
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/java/java.conf
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/java/font.properties
%config(noreplace,missingok) %verify(not md5 mtime size) /etc/env.d/*
%{_mandir}/man1/*
%{_javadir}-utils/*
%dir %{_mavendepmapdir}
%config(noreplace) %verify(not md5 mtime size) %{_mavendepmapdir}/maven2-depmap.xml
%dir %{_javadir}
%dir %{_javadir}-*
%docdir %{_javadocdir}
%dir %{_javadocdir}
%docdir %{_javasrcdir}
%dir %{_javasrcdir}

# arch dependant
%dir %{_jvmdir}
%dir %{_jvmjardir}
%dir %{_jvmprivdir}
%dir %{_jvmcommonlibdir}
%dir %{_jnidir}
%dir %{_jnidir}-*
%if "%{_lib}" != "lib"
%dir %{_ujvmdir}
%dir %{_ujvmjardir}
%dir %{_ujvmprivdir}
%dir %{_ujvmcommonlibdir}
%dir %{_ujnidir}
%dir %{_ujnidir}-*
%endif

# arch independant
%dir %{_jvmdatadir}
%dir %{_jvmsysconfdir}
%dir %{_jvmcommondatadir}
%dir %{_jvmcommonsysconfdir}

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: jpackage-utils.spec,v $
Revision 1.44  2010/04/21 11:36:44  jajcus
- fix build-classpath when $JAVA_HOME is set to a symlink
- Release: 3

Revision 1.43  2010/04/14 22:49:01  pawelz
- updated BR: rpmbuild(macros). Now it is >= 1.555.

Revision 1.42  2010/04/14 22:47:53  pawelz
- added %{_javasrcdir}
- rel 2

Revision 1.41  2009/04/13 20:02:18  megabajt
- R: which (for set_jvm() from /usr/share/java-utils/java-functions)

Revision 1.40  2009/02/07 17:30:44  pawelz
- up to 1.7.5

Revision 1.39  2008/07/28 12:43:39  arekm
- rel 4; try to get absolute paths; otherwise java-gcj-compat fails

Revision 1.38  2008/07/19 08:49:41  arekm
- rel 3; don't yell that java was not found

Revision 1.37  2007-12-31 16:35:20  glen
- rel 2

Revision 1.36  2007-12-15 20:21:19  qboosh
- cosmetics

Revision 1.35  2007-12-15 20:19:40  qboosh
- updated pl

Revision 1.34  2007-12-15 15:18:27  glen
- rel 1

Revision 1.33  2007-12-02 23:17:48  glen
- update to 1.7.3

Revision 1.32  2007-04-19 17:48:02  glen
- killed more bashism; rel 16

Revision 1.31  2007/04/17 23:39:09  glen
- bashism todo

Revision 1.30  2007/02/12 22:09:10  glen
- tabs in preamble

Revision 1.29  2007/02/12 01:06:42  baggins
- converted to UTF-8

Revision 1.28  2007/01/29 23:06:46  glen
- nevermind (misunderstood)

Revision 1.27  2007/01/29 18:50:15  glen
- add todo, rpm todo actually

Revision 1.26  2007/01/24 13:50:45  glen
- use %{_build_arch} macro, that at least exists

Revision 1.25  2007/01/24 13:48:53  glen
- do not package backup files

Revision 1.24  2007/01/23 23:05:33  glen
- add -errors.patch; rel 15

Revision 1.23  2007/01/23 11:58:22  glen
- add java-1.6.0 dirs; rel 14

Revision 1.22  2007/01/22 14:01:28  glen
- check for $JAVA_HOME being directory not just arbitary string; rel 13

Revision 1.21  2007/01/11 12:41:43  glen
- support 32-bit dirs on archs with lib64
- rel 12

Revision 1.20  2007/01/11 12:22:41  glen
- avoid $JAVA_HOME containing errors from set_jvm

Revision 1.19  2006/11/30 15:21:43  glen
- rel 11: do not set JAVA_HOME env file contents at compile time

Revision 1.18  2006/08/31 23:23:05  glen
- rel 10

Revision 1.17  2006/08/31 17:16:51  glen
- call env-update also in %postun, rel 9

Revision 1.16  2006/08/31 16:06:11  glen
- rel 8: added %env_update

Revision 1.15  2006/06/01 20:14:31  arekm
- rel 7; unset some variables to get proper JAVA_HOME

Revision 1.14  2006/05/25 23:29:46  qboosh
- docdir is only flag, dir must be added anyway

Revision 1.13  2006/05/25 11:06:22  jajcus
- %{_javadocdir} made %docdir

Revision 1.12  2006/05/25 09:11:04  jajcus
- this packaga is not noarch any more

Revision 1.11  2006/05/25 07:30:21  jajcus
- Release: 5
- use PLD rpm macros instead of those provided by jpackage-utils sources

Revision 1.10  2006/05/24 10:38:42  jajcus
- Release: 4

Revision 1.9  2006/05/23 20:32:47  glen
- rpm-javaprov removal cleanup

Revision 1.8  2006/05/23 20:16:32  glen
- macros.java dropped (rpm-build-macros >= 1.300 provide them)

Revision 1.7  2006/05/21 22:47:01  qboosh
- pl, missing defattr

Revision 1.6  2006/05/21 20:20:16  glen
- create rpm-javaprov similiar to other languages

Revision 1.5  2006/05/21 18:02:44  jajcus
- ignore environment settings when evaluating %{java_home} and %{java} macros

Revision 1.4  2006/05/20 19:20:58  jajcus
- Release: 2
- ExclusiveArch removed

Revision 1.3  2006/05/20 17:31:34  jajcus
- set $JAVA_HOME here, so it will work for any jpackage-compatible jvm package

Revision 1.2  2006/05/19 22:10:13  glen
- %distribution macro is undefined

Revision 1.1  2006/05/19 13:43:47  jajcus
- new spec
